
Square = gideros.class(Sprite)



function Square:init( mesh, i, x, y, size )

	
	self.square = {}
	self.square.mesh = mesh
	self.square.x = x
	self.square.y = y
	self.square.size = size


	local vstart=(i-1)*4
	local istart=(i-1)*6

	local i1, x1, y1 = vstart+1,x+0,y+0
	local i2, x2, y2 = vstart+2,x+size,y+0
	local i3, x3, y3 = vstart+3,x+size,y+size
	local i4, x4, y4 = vstart+4,x+0,y+size

	self.square.vertices_ =
	{
		i1=i1,x1=x1,y1=y1,
		i2=i2,x2=x2,y2=y2,
		i3=i3,x3=x3,y3=y3,
		i4=i4,x4=x4,y4=y4,
	} 

	mesh:setVertex(i1, x1, y1)
	mesh:setVertex(i2, x2, y2)
	mesh:setVertex(i3, x3, y3)
	mesh:setVertex(i4, x4, y4)

	local r = math.random(255)
	local g = math.random(255)
	local b = math.random(255)
	local a = math.random()

	local hexcol=rgb(r,g,b)

	mesh:setColor(vstart+1,hexcol,a)
	mesh:setColor(vstart+2,hexcol,a)
	mesh:setColor(vstart+3,hexcol,a)
	mesh:setColor(vstart+4,hexcol,a)

	mesh:setIndex(istart+1,vstart+1)
	mesh:setIndex(istart+2,vstart+2)
	mesh:setIndex(istart+3,vstart+3)
	mesh:setIndex(istart+4,vstart+1)
	mesh:setIndex(istart+5,vstart+3)
	mesh:setIndex(istart+6,vstart+4)

	--return square

end



function Square:setX_( x )

	--print("Square:setX_( x )", x)

	local i1 = self.square.vertices_.i1
	local i2 = self.square.vertices_.i2
	local i3 = self.square.vertices_.i3
	local i4 = self.square.vertices_.i4

	local x1 = x
	local x2 = x + self.square.size
	local x3 = x + self.square.size
	local x4 = x

	local y1 = self.square.vertices_.y1
	local y2 = self.square.vertices_.y2
	local y3 = self.square.vertices_.y3
	local y4 = self.square.vertices_.y4
	
	


	self.square.mesh:setVertex(i1,x1,y1)
	self.square.mesh:setVertex(i2,x2,y2)
	self.square.mesh:setVertex(i3,x3,y3)
	self.square.mesh:setVertex(i4,x4,y4)
	
	self.square.vertices_.x1 = x1
	self.square.vertices_.x2 = x2
	self.square.vertices_.x3 = x3
	self.square.vertices_.x4 = x4
	

end



function Square:setY_( y )

	--print("Square:setY_( y )", y)

	local i1 = self.square.vertices_.i1
	local i2 = self.square.vertices_.i2
	local i3 = self.square.vertices_.i3
	local i4 = self.square.vertices_.i4

	local x1 = self.square.vertices_.x1
	local x2 = self.square.vertices_.x2
	local x3 = self.square.vertices_.x3
	local x4 = self.square.vertices_.x4

	local y1 = y
	local y2 = y
	local y3 = y + self.square.size
	local y4 = y + self.square.size

	self.square.mesh:setVertex(i1,x1,y1)
	self.square.mesh:setVertex(i2,x2,y2)
	self.square.mesh:setVertex(i3,x3,y3)
	self.square.mesh:setVertex(i4,x4,y4)

	self.square.vertices_.y1 = y1
	self.square.vertices_.y2 = y2
	self.square.vertices_.y3 = y3
	self.square.vertices_.y4 = y4	


end

function Square:get( property )

	--print("Square:get( property )", property)

	if property == "x_" then
		return self:getX_()
	elseif property == "y_" then
		return self:getY_()
	end

end


function Square:set( property, value )
	
	--print("Square:set( property, value )", property, value)

	--local x, y = self:getPosition_()

	if type(property) == "string" then

		if property == "x_" then
			self:setX_( value )
		elseif property == "y_" then
			self:setY_( value )
		end
		
	end

end


function Square:getX_()

	--print("Square:getX()")

	return self.square.vertices_.x1

end

function Square:getY_()

	--print("Square:getY()")

	return self.square.vertices_.y1

end


function Square:setPosition_( x, y )

	--print("Square:setPosition_( x, y )", x, y)

	self:setX_(x)
	self:setY_(y)

end

function Square:getPosition_()

	--print("Square:getPosition_()")

	return self:getX_(), self:getY_()

end
