--

local test = "notween" -- 52fps on Nexus 6
--local test = "gtween" -- 29fps on Nexus 6
--local test = "movieclip" -- 16fps on Nexus 6


--

local floor, random = math.floor, math.random

function rgb(r,g,b)
   return floor(r)*65536+floor(g)*256+floor(b)
end

local mesh=Mesh.new()
local size=50
local squares = Squares.new(mesh)
squares:setY(100)
stage:addChild(squares)

math.randomseed( os.time() + math.random(1000) )

local random = math.random

local mcs = {}

for i=1, 1000 do

	local start_x = math.random(300) + 1
	local start_y = math.random(300) + 1
	
	local square = squares:create( size, start_x, start_y )	
	
	local target_x = math.random(300) + 1
	local target_y = math.random(300)	+ 1
	
	if test == "gtween" then

		local tween = GTween.new(square, 20, {x_=target_x, y_=target_y}, {ease=easing.inOutSine,useFrames=false,dispatchEvents=true})

	elseif test == "movieclip" then
	
		local mc = MovieClip.new{
			{1, 500, square, {x_ = {start_x, target_x, "inOutSine"}, y_ = {start_y, target_y, "inOutSine"}}},	
		}
		table.insert( mcs, mc ) -- needed to avoid garbage collection

	end
	

	
end

if test == "notween" then

	local update =
		function()
			local all_squares = squares:getAllSquares()
			for i=1, #all_squares do
				all_squares[i]:setPosition_( random(200), random(200) )
			end
		end

	-- Game loop
	local sprite_gameloop = Sprite.new()
	sprite_gameloop:addEventListener(Event.ENTER_FRAME, update )
	
end




-- Mem and fps
local sceneDebug = SceneDebug.new()
sceneDebug:addEventListener( Event.ENTER_FRAME, sceneDebug.update, sceneDebug )
stage:addChild( sceneDebug )
